## Run from tf_raycast:start_raycast

# Using dx for precise hitbox detection
# Parameters:
#     Edit not_mob.json in tags/entities to change which entities will not be targetted
#     Change the "positioned" offsets to change projectile size
#       - If > 1 block, just use one dx detection
execute as @e[tag=!raycasting,type=!#tf_raycast:not_mob,dx=0] positioned ~-0.9 ~-0.9 ~-0.9 if entity @s[dx=0,tag=!testhit18] positioned ~0.9 ~0.9 ~0.9 run function tf_raycast13_1:collide1

scoreboard players add .distance tf_rc 1

# Make raycast visible
particle dust_color_transition 0.439 1.000 0.945 1.5 0.259 0.259 0.259 ~ ~ ~ 0 0 0 1 0 normal

# Repeat the raycast if certain conditions are met
# Parameters:
#    (score after "matches") * (accuracy increment) = range
#    The "positioned" value specifies the precision
#    Edit raycast_pass.json in tags/blocks to change which blocks the raycast ignores
#    "rotated" controls arc/curve of raycast path
execute if score .distance tf_rc matches ..500 positioned ^ ^ ^0.1 rotated ~ ~ unless block ~ ~ ~ #tf_raycast1:raycast_pass run scoreboard players add .wall tf_rc 1
execute if score .distance tf_rc matches ..500 positioned ^ ^ ^0.1 rotated ~ ~ unless block ~ ~ ~ #tf_raycast1:raycast_pass if score .wall tf_rc matches ..25 run function tf_raycast13_1:raycast1
execute if score .distance tf_rc matches ..500 positioned ^ ^ ^0.1 rotated ~ ~ if block ~ ~ ~ #tf_raycast1:raycast_pass run function tf_raycast13_1:raycast1
